# MPI_Comm_dup

Duplicates an existing communicator with all its cached information

## Synopsis

    #include "mpi.h"
    int MPI_Comm_dup (
            MPI_Comm comm,
            MPI_Comm *comm_out )

## Input Parameter

comm
  communicator (handle)

## Output Parameter

newcomm
  A new communicator over the same group as `comm` but with a new context. See notes. (handle)

## Notes

This routine is used to create a new communicator that has a new communication context but contains the same group of processes as the input communicator. Since all MPI communication is performed within a communicator (specifies as the group of processes plus the context), this routine provides an effective way to create a private communicator for use by a software module or library. In particular, no library routine should use `MPI_COMM_WORLD` as the communicator; instead, a duplicate of a user-specified communicator should always be used. For more information, see Using MPI, 2nd edition.

Because this routine essentially produces a copy of a communicator, it also copies any attributes that have been defined on the input communicator, using the attribute copy function specified by the `copy_function` argument to `MPI_Keyval_create`. This is particularly useful for (a) attributes that describe some property of the group associated with the communicator, such as its interconnection topology and (b) communicators that are given back to the user; the attibutes in this case can track subsequent `MPI_Comm_dup` operations on this communicator.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Errhandler_set`; the predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_ERR_COMM
  Invalid communicator. A common error is to use a null communicator in a call (not even allowed in `MPI_Comm_rank`).

MPI_ERR_INTERN
  This error is returned when some part of the MPICH implementation is unable to acquire memory.

## See Also

MPI_Comm_free, MPI_Keyval_create, MPI_Attr_set, MPI_Attr_delete

Location:comm_dup.c